int n;
vector<int> adj[MAX_N];
int color[MAX_N];
bool shouldAddToCycle;
int end;
vector<int> cycle; 

bool dfsDetectCycle(int x) {
	color[x] = 1; // по пътя
	for (int neighbour : adj[x]) {
		if (color[neighbour] == 1) {
			cycle.push_back(x);
			end = neighbour;
			shouldAddToCycle = true;
			return true;
		}
		if (color[neighbour] == 0) {
			if (dfsDetectCycle(neighbour)) {
				if (shouldAddToCycle) {
					cycle.push_back(x);
				}
				if (end == x) {
					shouldAddToCycle = false;
				}
				return true;
			}
		}
	}
	color[x] = 2;
	return false;
}

void detectCycle() {
	for (int i = 1; i <= n; i ++) {
		color[i] = 0;
	}

	for (int i = 1; i <= n; i ++) {
		if (color[i] == 0) {
			if (dfsDetectCycle(i)) {
				return true;
			}
		}
	}

	return false;
}


int main() {
	//... 
	detectCycle();
}
